package com.dbxml.db.client.tools.command;

/*
 * dbXML - Native XML Database
 * Copyright (C) 1999-2004  The dbXML Group, L.L.C.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: Set.java,v 1.5 2004/02/12 00:17:55 bradford Exp $
 */

import com.dbxml.util.StringUtilities;
import com.dbxml.util.dbXMLException;
import java.io.PrintWriter;

/**
 * Set (SET) sets and display Command Line variables.
 */

public final class Set extends CommandBase {
   public void process() throws dbXMLException {
      PrintWriter pw = cl.getWriter();
      if ( cl.hasMoreTokens() ) {
         String parmName = cl.getNextToken();
         if ( cl.hasMoreTokens() ) {
            // Set the property to a new value
            cl.setProperty(parmName, cl.getNextToken());
            displayProperty(pw, parmName, cl.getProperty(parmName));
         }
      }
      else {
         // List all of the properties and their values
         String[] props = cl.listProperties();
         for ( int i = 0; i < props.length; i++ )
            displayProperty(pw, props[i], cl.getProperty(props[i]));
      }
   }

   private void displayProperty(PrintWriter pw, String name, Object value) {
      if ( value instanceof Boolean || value instanceof String || value instanceof Integer )
         pw.println(StringUtilities.leftJustify(name, 15) + " " + value);
      else
         pw.println(StringUtilities.leftJustify(name, 15) + " [Object]");
   }
}
